<template>
  <div>
    <h1>Usuários</h1>
    
    
    <b-button squared id="btn-incluir" class="mb-2 float-right" variant="success" @click="incluir">
        <b-icon icon="plus-circle"></b-icon>
    </b-button>
    <b-tooltip target="btn-incluir" triggers="hover">
        Novo usuário
    </b-tooltip>
    
    <b-table striped hover responsive 
        id="usuarios" 
        :busy = "busy"
        :fields="fields"
        :items="consultar">
        <template #cell(ativo)="data">
            <span>{{ data.value? 'Sim':'Não'}}</span>
        </template>
        <template #cell(acoes)="data">
            <b-button squared :id="`btn-alterar-${data.item.id}`" @click="alterar(data.item.id)" variant="warning" alt="Alterar">
                <b-icon icon="pencil-square"></b-icon>
            </b-button>
            <b-tooltip :target="`btn-alterar-${data.item.id}`" triggers="hover">
                Alterar
            </b-tooltip>
        </template>
    </b-table>
  </div>
</template>

<script>
  import axios from 'axios'

  export default {
    data() {
      return {
        busy:false,
        fields:[
            { key:'cpf', label:'CPF'},
            { key:'nome', label:'Nome'},
            { key:'email', label:'Email'},
            { key:'ativo', label:'Ativo'},
            { key:'acoes', label:'Ações'}
        ]
      }
    },
    methods: {
        consultar() {
          const config = {
            headers:{ Authorization: this.$store.state.token}
          }
          let promisse = axios.get("http://localhost:5555/identity/users", config)
          return promisse
              .then(({data}) => { 
                const dataTable = data.content;
                dataTable.forEach(data => {
                  data.cpf = this.formataCpf(data.cpf)
                });
                return dataTable;
              })
              .catch(() => { return []})
        },
        incluir() {
          this.$router.push("/auth/usuario/novo")
        },
        alterar(id) {
          this.$router.push(`/auth/usuario/${id}`)
        },
        formataCpf(cpf){
          return cpf.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
        }
    }
  }
</script>
